/* tslint:disable */
/* eslint-disable */
/**
 * Golemio COVID-19 Prague API
 * API for multiple reservation system for samling points of COVID19
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    SamplingPointsOutput,
    SamplingPointsOutputFromJSON,
    SamplingPointsOutputToJSON,
} from '../models';

export interface SamplingPointsRequest {
    lang?: SamplingPointsLangEnum;
    district?: Array<string>;
    serviceRequestType?: SamplingPointsServiceRequestTypeEnum;
    serviceQueueType?: SamplingPointsServiceQueueTypeEnum;
    serviceProcessType?: SamplingPointsServiceProcessTypeEnum;
    serviceSlotsFreeFrom?: Date;
    serviceSlotsFreeTo?: Date;
}

/**
 * 
 */
export class SamplingPointsApi extends runtime.BaseAPI {

    /**
     * List of all Sampling Points
     */
    async samplingPointsRaw(requestParameters: SamplingPointsRequest): Promise<runtime.ApiResponse<SamplingPointsOutput>> {
        const queryParameters: any = {};

        if (requestParameters.lang !== undefined) {
            queryParameters['lang'] = requestParameters.lang;
        }

        if (requestParameters.district) {
            queryParameters['district'] = requestParameters.district;
        }

        if (requestParameters.serviceRequestType !== undefined) {
            queryParameters['service_request_type'] = requestParameters.serviceRequestType;
        }

        if (requestParameters.serviceQueueType !== undefined) {
            queryParameters['service_queue_type'] = requestParameters.serviceQueueType;
        }

        if (requestParameters.serviceProcessType !== undefined) {
            queryParameters['service_process_type'] = requestParameters.serviceProcessType;
        }

        if (requestParameters.serviceSlotsFreeFrom !== undefined) {
            queryParameters['service_slots_free_from'] = (requestParameters.serviceSlotsFreeFrom as any).toISOString();
        }

        if (requestParameters.serviceSlotsFreeTo !== undefined) {
            queryParameters['service_slots_free_to'] = (requestParameters.serviceSlotsFreeTo as any).toISOString();
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/samplingpoints`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => SamplingPointsOutputFromJSON(jsonValue));
    }

    /**
     * List of all Sampling Points
     */
    async samplingPoints(requestParameters: SamplingPointsRequest): Promise<SamplingPointsOutput> {
        const response = await this.samplingPointsRaw(requestParameters);
        return await response.value();
    }

}

/**
    * @export
    * @enum {string}
    */
export enum SamplingPointsLangEnum {
    Cs = 'cs',
    En = 'en'
}
/**
    * @export
    * @enum {string}
    */
export enum SamplingPointsServiceRequestTypeEnum {
    Selfpaid = 'selfpaid',
    Agtests = 'agtests',
    Application = 'application'
}
/**
    * @export
    * @enum {string}
    */
export enum SamplingPointsServiceQueueTypeEnum {
    Reservation = 'reservation',
    Queue = 'queue'
}
/**
    * @export
    * @enum {string}
    */
export enum SamplingPointsServiceProcessTypeEnum {
    Walk = 'walk',
    Drivein = 'drivein',
    Queue = 'queue'
}
